#include "para.h"

/* if line handler is NULL, return number of complete lines in buf.
 * Otherwise, call line_handler for each complete line, but no more than
 * num times. Copy rest of buffer (last chunk containing incomplete line)
 * to start of buffer and return its size.
 */
int check_buf_for_items(char *buf, int n, void (*line_handler)(char *), int num)
{
	char *start = buf, *end;
	int i, num_lines = 0;
	char tmp[STRINGSIZE];
	
//		if (num) {
//			char tmp[100];
//			sprintf(tmp, "%d", num);
//			add_output_line(tmp);
//			sleep(1);
//		}

	while (start <= buf + n) {
		char *next_null;
		char *next_cr;

		next_cr = memchr(start, '\n', buf + n - start);
		next_null = memchr(start, '\0', buf + n - start);
		if (next_null == start) {
			start++;
			continue;
		}
		if (!next_cr && !next_null)
			break;
		if (next_cr && next_null) {
//			add_output_line("bar\n");
			end = next_cr < next_null? next_cr : next_null;
		} else if (next_null) {
//			add_output_line("baz\n");
			end = next_null;
		} else
			end = next_cr;
//		sprintf(tmp, "end = %lx\n", (long) end);
//		add_output_line(tmp);
//		add_output_line("qux\n");
		num_lines++;
		if (line_handler) {
			*end = '\0';
			line_handler(start);
			start = ++end;
			if (num && num_lines >= num)
				break;
		} else
			start = ++end;
	}
	if (!line_handler)
		return num_lines;
	i = buf + n - start;
	memcpy(tmp, start, i);
	memcpy(buf, tmp, i);
	return i;
}



FILE *open_stat_pipe(void)
{
	return popen_read_client_cmdline("stat");
}

